import { children, elements, html } from "@microsoft/fast-element";
function createRowItemTemplate(prefix) {
    return html `
    <${prefix}-data-grid-row
        :rowData="${x => x}"
        :cellItemTemplate="${(x, c) => c.parent.cellItemTemplate}"
        :headerCellItemTemplate="${(x, c) => c.parent.headerCellItemTemplate}"
    ></${prefix}-data-grid-row>
`;
}
/**
 * Generates a template for the {@link @microsoft/fast-foundation#DataGrid} component using
 * the provided prefix.
 *
 * @public
 */
export function createDataGridTemplate(prefix) {
    const rowItemTemplate = createRowItemTemplate(prefix);
    return html `
        <template
            role="grid"
            tabindex="0"
            :defaultRowItemTemplate="${rowItemTemplate}"
            ${children({
        property: "rowElements",
        filter: elements("[role=row]"),
    })}
        >
            <slot></slot>
        </template>
    `;
}
